    /*

    Copyright (C) 1998 Stefan Westerfeld
                       stefan@space.twc.de

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    */

#ifndef _ARTS_MIDI_H
#define _ARTS_MIDI_H

#include "midibus.h"
#include "synthmodule.h"

class MidiReceiver
{
public:
	virtual void noteOn (int channel, int note, int velocity) = 0;
	virtual void noteOff (int channel, int note) = 0;
};

class MidiChannel_impl : virtual public MidiChannel_skel
{
  protected:
	list <MidiReceiver *> receivers;
  public:
    void noteOn( CORBA::Octet channel, CORBA::Octet note, CORBA::Octet volume );
    void noteOff( CORBA::Octet channel, CORBA::Octet note );
	void subscribe (MidiReceiver *receiver);
	void unSubscribe (MidiReceiver *receiver);
};

#endif /* _ARTS_MIDI_H*/
